/*
 * Mega 88 temperatur display
 *
 * 05-10-2015 12:44:36
 * 
 */ 

#include <avr/io.h>
#include <stdio.h>
#include <math.h>

#define SET(x,y) (x |=(1<<y))							//-Bit set/clear macros
#define CLR(x,y) (x &= (~(1<<y)))       				// |
#define CHK(x,y) (x & (1<<y))           				// |
#define TOG(x,y) (x^=(1<<y))            				//-+

unsigned int analog;
unsigned int analogavarage =0;
unsigned char avaragecounter = 0;
unsigned int analogresult=0;

unsigned int analogavarage1 = 0;
unsigned char avaragecounter1 = 0;
unsigned int analogresult1=0;

unsigned char positivtemperatur = 1;
unsigned char hund;
unsigned char tier;
unsigned char ener;

unsigned int readout;
signed int   temperature_min;
signed int   temperature_max;

void KONVERTER(konv)        
{                               
  hund = 0;  // hund
  tier = 0;  // tens
  ener = 0;  // ones

  while (konv>=100)          
  {
    konv = konv-100;
    hund++;
  }
  while (konv>=10)          
  {
    konv=konv-10;
    tier++;
  }
  ener=konv;   // resten
}

//*****************************************************************************
//*	ADC  Conversion time: 208uS
//*****************************************************************************
void adc_init(void)
{
  ADCSRA = 0x00; //disable adc
  ADMUX = 0b11000000;  //intern 1.1V ref, select adc input 0
  ACSR  = 0x80;
  ADCSRB = 0x00;
  ADCSRA = 0b10000110;  // adc enable, 64 div
  DIDR0=0b00111111;
}


void adc_start()
{
  SET(ADCSRA,ADSC); //start conv, the smart way, so adc setup routine works
  while(CHK(ADCSRA,ADSC));    //-Wait for result
  analog=ADC; // get 10bit adc value
}



void SkrivLED(unsigned char tallet)
{
  // PORTD = 0b11111111;	// sluk alt
   SET(PORTD,7); SET(PORTD,5); SET(PORTD,4); SET(PORTD,3);    SET(PORTD,2);    SET(PORTD,1);    SET(PORTD,0);  // sluk alt
   
   PORTB = 0b11111111;  // sluk alt 2 1 0 er LED driver
   if (tallet==0)
   {
	   CLR(PORTD,2); // A  CLR = LYS
	   CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   CLR(PORTB,7); // D
	   CLR(PORTD,5); // E
	   CLR(PORTD,3); // F
	   //CLR(PORTB,6); // G
   }
   
   if (tallet==1)
   {
	   //CLR(PORTD,2); // A
	   CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   //CLR(PORTB,7); // D
	   //CLR(PORTD,5); // E
	   //CLR(PORTD,3); // F
	   //CLR(PORTB,6); // G
   }
      if (tallet==2)
   {
	   CLR(PORTD,2); // A
	   CLR(PORTD,4); // B
	   //CLR(PORTD,7); // C
	   CLR(PORTB,7); // D
	   CLR(PORTD,5); // E
	   //CLR(PORTD,3); // F
	   CLR(PORTB,6); // G
   }
      if (tallet==3)
   {
	   CLR(PORTD,2); // A
	   CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   CLR(PORTB,7); // D
	   //CLR(PORTD,5); // E
	   //CLR(PORTD,3); // F
	   CLR(PORTB,6); // G
   }
      if (tallet==4)
   {
	   //CLR(PORTD,2); // A
	   CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   //CLR(PORTB,7); // D
	   //CLR(PORTD,5); // E
	   CLR(PORTD,3); // F
	   CLR(PORTB,6); // G
   }
      if (tallet==5)
   {
	   CLR(PORTD,2); // A
	   //CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   CLR(PORTB,7); // D
	   //CLR(PORTD,5); // E
	   CLR(PORTD,3); // F
	   CLR(PORTB,6); // G
   }
         if (tallet==6)
   {
	   CLR(PORTD,2); // A
	   //CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   CLR(PORTB,7); // D
	   CLR(PORTD,5); // E
	   CLR(PORTD,3); // F
	   CLR(PORTB,6); // G
   }  
       if (tallet==7)
   {
	   CLR(PORTD,2); // A
	   CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   //CLR(PORTB,7); // D
	   //CLR(PORTD,5); // E
	   //CLR(PORTD,3); // F
	   //CLR(PORTB,6); // G
   }  
   if (tallet==8)
   {
	   CLR(PORTD,2); // A
	   CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   CLR(PORTB,7); // D
	   CLR(PORTD,5); // E
	   CLR(PORTD,3); // F
	   CLR(PORTB,6); // G
   }
   
   if (tallet==9)
   {
	   CLR(PORTD,2); // A
	   CLR(PORTD,4); // B
	   CLR(PORTD,7); // C
	   //CLR(PORTB,7); // D
	   //CLR(PORTD,5); // E
	   CLR(PORTD,3); // F
	   CLR(PORTB,6); // G
   }
   if (tallet==10) // minus tegnet er 10
   {
	   //CLR(PORTD,2); // A
	   //CLR(PORTD,4); // B
	   //CLR(PORTD,7); // C
	   //CLR(PORTB,7); // D
	   //CLR(PORTD,5); // E
	   //CLR(PORTD,3); // F
	   CLR(PORTB,6); // G
   }
}



int    usersInt;
long  temperature_adc_raw;
long temperature_adc_filter;
unsigned int temperature_filter_counter = 0;
signed int   temperature; // temp measurement error compensated in Celsius
unsigned char temperatureSP = 160; // + 100 = 26.0 C default set point
unsigned int temperature_raw; // raw measurement
unsigned char newtemp = 0;
unsigned char newtemp_avg = 0;	
float fl1;
float fl2;
float filter;

void GetTemperatureSensor(void)
{
     adc_start();
	 
	// analog = 540; // test 25.0
	// analog = 161; // test -40.0
	 
	 
	 filter = (filter*0.999)+(analog*0.001);
	 
     fl1 += filter;
	 
     temperature_filter_counter++;
	 if(temperature_filter_counter>106) // how many mV pr adc count 1.075mV
	 {
	    fl2 = (fl1 - 42400)/62;
		temperature = fl2+3;       // CALIBRATE + 0.03 C OFSET
		fl1=0;
		temperature_adc_filter = 0; // make ready for next filter loop
		temperature_filter_counter = 0;
		newtemp=1;
		if (temperature>temperature_max) temperature_max = temperature;
		if (temperature<temperature_min) temperature_min = temperature;
				
		if (!CHK(PINB,5)) // venstre
		{
		   if (!CHK(PINB,3)) temperature_min = temperature;
           temperature = temperature_min;
		}		   
		if (!CHK(PINB,4)) // hjre
		{
		   if (!CHK(PINB,3)) temperature_max = temperature;		   
           temperature=temperature_max;
		}		   
		
		positivtemperatur =1;
        if (temperature<0) 
		{   
            //temperature=0; // 
			positivtemperatur = 0;
			temperature = fabs(temperature);
			
		}			
        if (temperature>=999) temperature=999; // limit system to 99.9 C

		
	 }     
 }

int main(void)
{
	PORTB =0b00111000;  // aktiver intern pullup
	DDRB = 0b11000111; // bit 0 1 2 6 7 er sat til udgang
	DDRD = 0b11111111; // alle sat til udgang

	adc_init();
	
    while(1)
    {


	  GetTemperatureSensor();
		
	  readout = temperature;
		
	  KONVERTER(readout);	
	  
	  if (positivtemperatur) SkrivLED(hund);
	  else SkrivLED(10);
	  CLR(PORTB,1); // hund
      Delay(50);
      SET(PORTB,1); // hund // SLUK
	  Delay(1);

	  if (positivtemperatur)
	  {
         SkrivLED(tier);
		 CLR(PORTD,6); // punkt
	  }	  	 
	  else SkrivLED(hund);
	  CLR(PORTB,2); // tier
      Delay(50);
      SET(PORTB,2); // tier // SLUK
      SET(PORTD,6); // punkt
      Delay(1);
	  	  	  
	  if (positivtemperatur)  SkrivLED(ener);
	  else SkrivLED(tier);
	  CLR(PORTB,0); // enere
      Delay(50);
	  SET(PORTB,0); // enere SLUK
      Delay(1);
    } // while 1
}//main